import sortalgi as _sgi

ag_empty = {}
ag_square = {
    'line segments': [
        ((( 20,  20, 0), ( 20,  80, 0)), {'weight': 1.7}), 
        ((( 20,  20, 0), ( 80,  20, 0)), {'weight': 1.7}), 
        ((( 20,  80, 0), ( 80,  80, 0)), {'weight': 1.7}), 
        ((( 80,  20, 0), ( 80,  80, 0)), {'weight': 1.7})]}
ag_ells = {
    'line segments': [
        (((  0,  20, 0), ( 20,  20, 0)), {'weight': 1.7}), 
        (((  0,  80, 0), ( 20,  80, 0)), {'weight': 1.7}), 
        ((( 20,   0, 0), ( 20,  20, 0)), {'weight': 1.7}), 
        ((( 20,  80, 0), ( 20, 100, 0)), {'weight': 1.7}), 
        ((( 80,   0, 0), ( 80,  20, 0)), {'weight': 1.7}), 
        ((( 80,  20, 0), (100,  20, 0)), {'weight': 1.7}), 
        ((( 80,  80, 0), ( 80, 100, 0)), {'weight': 1.7}), 
        ((( 80,  80, 0), (100,  80, 0)), {'weight': 1.7})], 
    'points': [
        ((  0,  20, 0), {'labels': ['a']}), 
        ((  0,  80, 0), {'labels': ['a']}), 
        (( 20,   0, 0), {'labels': ['a']}), 
        (( 20, 100, 0), {'labels': ['a']}), 
        (( 80,   0, 0), {'labels': ['a']}), 
        (( 80, 100, 0), {'labels': ['a']}), 
        ((100,  20, 0), {'labels': ['a']}), 
        ((100,  80, 0), {'labels': ['a']})]}
ag_hash = {
    'line segments': [
        (((  0,  20, 0), (100,  20, 0)), {'weight': 1.7}), 
        (((  0,  80, 0), (100,  80, 0)), {'weight': 1.7}), 
        ((( 20,   0, 0), ( 20, 100, 0)), {'weight': 1.7}), 
        ((( 80,   0, 0), ( 80, 100, 0)), {'weight': 1.7})], 
    'points': [
        ((  0,  20, 0), {'labels': ['a']}), 
        ((  0,  80, 0), {'labels': ['a']}), 
        (( 20,   0, 0), {'labels': ['a']}), 
        (( 20, 100, 0), {'labels': ['a']}), 
        (( 80,   0, 0), {'labels': ['a']}), 
        (( 80, 100, 0), {'labels': ['a']}), 
        ((100,  20, 0), {'labels': ['a']}), 
        ((100,  80, 0), {'labels': ['a']})]}

def reset_sortal():
    _sgi.sortal_setup(
        (   (True, True, True, True, True, True, True), 
            (True, True, True, True, True, True, True)))

def test_find_rule_appns():                     ##  2017-11-15 15:53
    rule_name = 'delete_ells'
    rule_descr = 'deletes ells'
    ag_left = ag_ells
    ag_right = ag_empty
    sgi_rule, sgi_rule_name = _sgi.create_rule(
        rule_name, rule_descr, ag_left, ag_right)
    ag_shape = ag_hash
    sub_ag_shape = ag_hash
    appns = _sgi.find_rule_appns(sgi_rule, ag_shape, sub_ag_shape)
    if len(appns) == 1:
        t, t_of_a_in_d, t_of_b, ag_next = appn = appns[0]
        as_expected = (ag_next == ag_square)
        print('as_expected: %s' % as_expected)
        print('expected: %s' % str(ag_square))
        print('got: %s' % str(ag_next))
    else:
        print('len(appns): %i' % len(appns))        

"""
expected: {
    'line segments': [
        (((20, 20, 0), (20, 80, 0)), {'weight': 1.7}), 
        (((20, 20, 0), (80, 20, 0)), {'weight': 1.7}), 
        (((20, 80, 0), (80, 80, 0)), {'weight': 1.7}), 
        (((80, 20, 0), (80, 80, 0)), {'weight': 1.7})]}
got: {
    'line segments': [
        (((20.0, 20.0, 0.0), (20.0, 80.0, 0.0)), {'weight': 1.0}), 
        (((80.0, 20.0, 0.0), (80.0, 80.0, 0.0)), {'weight': 1.0}), 
        (((20.0, 20.0, 0.0), (80.0, 20.0, 0.0)), {'weight': 1.0}), 
        (((20.0, 80.0, 0.0), (80.0, 80.0, 0.0)), {'weight': 1.0})]}
"""

reset_sortal()
test_find_rule_appns()
