from controller import controller_main as       _cm
import sortalgi as                              _sgi
from tests import test_utilities as             _tu

cm = _cm.ControllerMain()

def reset_sortal():
    _sgi.sortal_setup(
        (   (True, True, True, True, True, True, True), 
            (True, True, True, True, True, True, True)))

def test_find_rule_appns_square_and_ells():     ##  2017-11-16 09:05
    method_name = 'find_rule_appns_square_and_ells'
    try_names = [
        'square_minus_ell_11', 
        'square_minus_ell_12', 
        'square_minus_ell_21', 
        'square_minus_ell_22', 
    ]
    d = _tu.make_square_suite_ag_dict()
    tuples = [
        (d['sr_ell_11_to_empty'], d['ag_square'], d['ag_square']), 
        (d['sr_ell_12_to_empty'], d['ag_square'], d['ag_square']), 
        (d['sr_ell_21_to_empty'], d['ag_square'], d['ag_square']), 
        (d['sr_ell_22_to_empty'], d['ag_square'], d['ag_square']), 
    ]
    expected_value_lists = [
        [d['ag_ell_11'], d['ag_ell_12'], d['ag_ell_21'], d['ag_ell_22']], 
        [d['ag_ell_11'], d['ag_ell_12'], d['ag_ell_21'], d['ag_ell_22']], 
        [d['ag_ell_11'], d['ag_ell_12'], d['ag_ell_21'], d['ag_ell_22']], 
        [d['ag_ell_11'], d['ag_ell_12'], d['ag_ell_21'], d['ag_ell_22']], 
    ]
    _try_find_rule_appns_square_and_ells(
        method_name, try_names[i], tuples[i], expected_value_lists[i])
    print_test_done(method_name)

def _try_find_rule_appns_square_and_ells(
    method_name, try_name, tuple_, expected_ag_shapes
):
    expected_py_forms = _pf.PyForm.some_new_from_agnostics(expected_ag_shapes)
    sgi_rule, ag_shape, sub_ag_shape = tuple_
    actual_appns = _sgi.find_rule_appns(sgi_rule, ag_shape, sub_ag_shape)
    actual_ag_shapes = cm._extract_ag_shapes_from_appns(actual_appns)
    actual_py_forms = _pf.PyForm.some_new_from_agnostics(actual_ag_shapes)
    if not sorted(actual_py_forms) == sorted(expected_py_forms):
        print_test_error_message(
            method_name, try_name, expected_py_forms, actual_py_forms)

reset_sortal()
test_find_rule_appns_square_and_ells()
