import sortalgi as                              _sgi
import                                          sortal
from tests import test_utilities as             _tu

print_test_done = _tu.print_test_done
print_test_error_message = _tu.print_test_error_message

def reset_sortal():
    _sgi.sortal_setup(
        # (   (True, True, True, True, True, True, True), 
        #     (True, True, True, True, True, True, True))
        )

def test_create_rule():
    method_name = 'create_rule'
    try_names = [
        'delete_labeled_point', 
        'delete_ells', 
        'delete_square', 
        'delete_hash', 
    ]
    ag_point = {
        'points': [
            ((0, 0, 0), {'labels': ['a']})]
        # 'line segments': [], 
        }
    ag_empty, ag_square, ag_ells, ag_hash = (
        _tu.make_hash_suite_ags())
    tuples = [
        ('delete point', 'deletes point', ag_point, ag_empty), 
        ('delete ells', 'deletes ells', ag_ells, ag_empty), 
        ('delete square', 'deletes square', ag_square, ag_empty), 
        ('delete hash', 'deletes hash', ag_hash, ag_empty), 
    ]
    expected_values = [
        (sortal.grammar.rules.rule.rule, 'delete point'), 
        (sortal.grammar.rules.rule.rule, 'delete ells'), 
        (sortal.grammar.rules.rule.rule, 'delete square'), 
        (sortal.grammar.rules.rule.rule, 'delete hash'), 
    ]
    n = len(try_names)
    for i in range(n):
        _try_delete_labeled_point(
            method_name, try_names[i], tuples[i], expected_values[i])
    print_test_done(method_name)

def _try_delete_labeled_point(
    method_name, try_name, tuple_, expected_value
):
    rule_name, rule_descr, ag_left, ag_right = tuple_
    actual_rule, actual_rule_name = _sgi.create_rule(
        rule_name, rule_descr, ag_left, ag_right)
    actual_rule_type = type(actual_rule)
    actual_value = (actual_rule_type, actual_rule_name)
    # if actual_value == expected_value:
    if not actual_value == expected_value:
        print_test_error_message(
            method_name, try_name, expected_value, actual_value)

reset_sortal()
test_create_rule()

