# -*- coding: utf-8 -*-
"""
Created on Fri Jan  6 14:53:36 2017

@author: akidribm
"""
from __future__ import unicode_literals
from __future__ import print_function
from __future__ import division
from __future__ import absolute_import

from sortal import (primitiveSort, point2D, lineSegment2D, point3D, lineSegment3D, 
                    color, label, rWeight, enumerative, disjunctiveSort, 
                    attributeSort, planeSegment2D, planeSegment3D, description, sort)
                    
"""
=========
FILE INFO
=========

Defines primitive sort types
These are used to compose the discursive sort that feeds into parse_disjunctive_sort 
and other applications, e.g. create_rule.py, apply_rule.py
"""

arg = '{black,white}[black white white white]'
enumSort = primitiveSort('enumerative', enumerative, arg)

# Weight attribute definitions
# rWeight or weight can be used, with the crucial difference being
# rWeight - arithmetic operations on values
# weight - ordinal operations on values
# rWeight does not require an upper limit, but one may be specified
# This upper limit weight value is the value all weightSort individuals are maximised to 
# when any value above the former is stored in the sortal library
weightSort = primitiveSort('weight', rWeight)
weight255Sort = primitiveSort('weight255', rWeight, '255')

# Other attribute types
labelSort = primitiveSort('label', label)
descSort = primitiveSort('description', description)
colorSort = primitiveSort('color',color,'RGB RGB_SUM,')

pointSort3D = primitiveSort('point3D', point3D)
lineSegSort3D = primitiveSort('lineSeg3D', lineSegment3D)



