from view import draw as                _d
import rhinoscriptsyntax as             _rs
from view import settings as            _s

origin = _s.Settings.origin

class Line(object):
    """A single straight line, i.e., not a curved line, polyline, or 
    rectangle. 
    """
    def __init__(self):
        pass

    @classmethod
    def draw_random_lines(cls, n=2, ref_point=origin, rel_location='i'):
        lines = []
        for i in range(n):
            xyz_pair = _d.Draw.make_random_xyz_pair(ref_point, rel_location)
            line = cls.draw(xyz_pair[0], xyz_pair[1])
            lines.append(line)
        return lines

    @classmethod
    def draw_random(cls, ref_point=origin, rel_location='i'):
        xyz_pair = _d.Draw.make_random_xyz_pair(ref_point, rel_location)
        line = cls.draw(xyz_pair[0], xyz_pair[1])
        return line

    @classmethod
    def draw(cls, xyz1, xyz2):
        line = _rs.AddLine(xyz1, xyz2)
        return line

    @classmethod
    def is_line(cls, object_):
        """Receives:
            object_         guid
        Returns:
            value           boolean. True if object_ is a line (not a 
                            polyline, rectangle, etc.). False otherwise
        """
        value = False
        if (
            _rs.ObjectType(object_) == _s.Settings.curve_type and
            _rs.IsLine(object_)
        ):
            value = True
        return value

    @classmethod
    def get_agnostic(cls, line):
        """Receives:
            line            guid
        Returns:
            line_ag         (xyzs, attribs)
                xyzs        (xyz, xyz)
                xyz         (num, num, num). A coordinate of the line
                attribs     [attrib, ...]. A list of attributes. Not yet 
                            implemented
                attrib      'attrib=<attrib>'
        """
        pass


