from view import draw as                        _d
from view import grammar as                     _g
import rhinoscriptsyntax as                     _rs
from view.tests import test_utilities as        _tu
from view import view_main as                   _vm

print_test_error_message = _tu.print_test_error_message

def test_is_empty():
    method_name = 'is_empty'
    try_names = [
        'objects', 
        'no_objects', 
    ]
    setup_object_lists = [
        [   'points', 
            'curves', 
            'polylines', 
            'rectangles', 
            'lines', 
            'text_dots', 
            'others'], 
        [], 
    ]
    expected_values = [
        False, 
        True, 
    ]
    n = len(try_names)
    for i in range(n):
        _try_is_empty(
            method_name, try_names[i], expected_values[i], setup_object_lists[i])
    print("Done: test_%s" % method_name)

def _try_is_empty(method_name, try_name, expected_value, setup_objects):
    _vm.ViewMain.clear_all()
    _d.Draw.draw_objects(setup_objects)
    actual_value = _g.Grammar.is_empty()
    if not actual_value == expected_value:
        print_test_error_message(
            method_name, try_name, expected_value, actual_value)

test_is_empty()
