from view import draw as                        _d
from view import frame as                       _fr
from view import line as                        _l
import rhinoscriptsyntax as                     _rs
from view import text_dot as                    _td
from view.tests import test_utilities as        _tu
from view import view_main as                   _vm

print_test_error_message = _tu.print_test_error_message
origin = (0, 0, 0)

def test_is_line():
    method_name = 'is_line'
    try_names = [
        'point', 
        'curve', 
        'rectangle', 
        'polyline', 
        'line', 
        'text_dot', 
        'frame', 
    ]
    setup_reprs = [
        "_d.Draw.draw_random_point()", 
        "_d.Draw.draw_random_curve()", 
        "_d.Draw.draw_random_rectangle()", 
        "_d.Draw.draw_random_polyline()", 
        "_l.Line.draw_random()", 
        "_td.TextDot.draw_random()", 
        "_fr.Frame.new_instance(_rs.CurrentLayer(), origin)", 
    ]
    expected_values = [
        False, 
        False, 
        False, 
        False, 
        True, 
        False, 
        False, 
    ]
    n = len(try_names)
    for i in range(n):
        try_is_line(
            method_name, try_names[i], setup_reprs[i], expected_values[i])
    print("Done: test_%s" % method_name)

def try_is_line(method_name, try_name, setup_repr, expected_value):
    _vm.ViewMain.clear_all()
    object_ = eval(setup_repr)
    actual_value = _l.Line.is_line(object_)
    if not actual_value == expected_value:
        print_test_error_message(
            method_name, try_name, expected_value, actual_value)

test_is_line()
