from view import agnostic as                    _a
from view import layer as                       _l
import                                          math
from view import py_line as                     _pl
import rhinoscriptsyntax as                     _rs
from view import settings as                    _s
from view.tests import test_utilities as        _tu
from view import view_main as                   _vm
from view import view_utilities as              _vu

print_test_done = _tu.print_test_done
print_test_error_message = _tu.print_test_error_message
TAU = math.pi * 2

def test___init__():
    method_name = '__init__'
    try_names = [
        'xyz_bad_container', 
        'xyz_bad_length',   
        'xyz_bad_type_element', 
        'xyz_bad_value',
        'labels_bad_container_type', 

        'labels_bad_element_type', 
        # 'labels_bad_type', 
        'labels_bad_value', 
        'labels', 
        'weight_bad_type', 

        'weight_bad_value', 
        'xyz1_smaller',
        'xyz2_smaller',
        'empty_labels', 
        'no_labels_no_weight', 

    ]
    input_tuples = [
        (( 10, 20, 30), 'x',          ['a'],      0.1), 
        ((  0,  0    ), (10, 20, 30), ['b'],      0.2), 
        (('x',  0,  0), (10, 20, 30), ['c'],      0.3), 
        (( 10, 20, 30), (10, 20, 30), ['d'],      0.4), 
        (( 10, 20, 30), (10, 20, 30), ('e'),      0.5), 

        (( 10, 20, 30), (10, 20, 30), ['f', 1.2], 0.6), 
        # (( 10, 20, 30), ( 0,  0,  0), 1.2,        0.7), 
        (( 10, 20, 30), ( 0,  0,  0), ['h', 'h'], 0.8), 
        (( 10, 20, 30), ( 0,  0,  0), ['j', 'i'], 0.9), 
        (( 10, 20, 30), ( 0,  0,  0), 'j',        'x'), 

        (( 10, 20, 30), ( 0,  0,  0), 'k',       -1.1), 
        ((  0,  0,  0), (10, 20, 30), 'l',        1.2), 
        (( 10, 20, 30), ( 0,  0,  0), 'm',        1.3), 
        (( 10, 20, 30), ( 0,  0,  0), [],         1.4), 
        (( 10, 20, 30), ( 0,  0,  0), None,       None), 
    ]
    expected_values = [
        False, 
        False, 
        False, 
        False, 
        False, 

        False, 
        # False, 
        (   (   ((0, 0, 0), (10, 20, 30)), 
                {   'labels': ['h'], 
                    'weight': 0.8}), 
            "((0, 0, 0), (10, 20, 30), ['h'], 0.8)"), 
        (   (   ((0, 0, 0), (10, 20, 30)), 
                {   'labels': ['i', 'j'], 
                    'weight': 0.9}), 
            "((0, 0, 0), (10, 20, 30), ['i', 'j'], 0.9)"), 
        False, 

        False, 
        (   (   ((0, 0, 0), (10, 20, 30)), 
                {   'labels': ['l'], 
                    'weight': 1.2}), 
            "((0, 0, 0), (10, 20, 30), ['l'], 1.2)"), 
        (   (   ((0, 0, 0), (10, 20, 30)), 
                {   'labels': ['m'], 
                    'weight': 1.3}), 
            "((0, 0, 0), (10, 20, 30), ['m'], 1.3)"), 
        (   (   ((0, 0, 0), (10, 20, 30)), 
                {   'labels': [], 
                    'weight': 1.4}), 
            "((0, 0, 0), (10, 20, 30), [], 1.4)"), 
        (   (   ((0, 0, 0), (10, 20, 30)), 
                {   'labels': [], 
                    'weight': 1.0}), 
            "((0, 0, 0), (10, 20, 30), [], 1.0)"), 
    ]
    n = len(try_names)
    for i in range(n):
        _try___init__(
            method_name, try_names[i], input_tuples[i], expected_values[i])
    print_test_done(method_name)

def _try___init__(method_name, try_name, input_tuple, expected_value):
    xyz1, xyz2, label, weight = input_tuple
    if (label == None and 
        weight == None
    ):
        output_ = _pl.PyLine(xyz1, xyz2)
    else:
        output_ = _pl.PyLine(xyz1, xyz2, label, weight)
    if output_.is_well_formed:
        py_line = output_
        actual_value = (py_line.agnostic, str(py_line))
    else:
        actual_value = output_.is_well_formed
    if not actual_value == expected_value:
        print_test_error_message(
            method_name, try_name, expected_value, actual_value)

def test_some_new_from_rh_lines_and_ref_point():
    method_name = 'some_new_from_rh_lines_and_ref_point'
    try_names = [
        'rh_lines_123, p0', 
        'rh_lines_123, p1', 
    ]
    _vm.ViewMain.clear_all()
    points = [_vu.get_point3d(
        (10 * i, 10 * i, 10 * i)) for i in range(5)]
    rh_lines = [_rs.AddLine(points[i], points[i + 1]) for i in range(4)]
    for rh_line in rh_lines:
        _rs.ObjectName(rh_line, 'x')
    rh_lines_123 = rh_lines[1:4]
    pairs_in = [
        (rh_lines_123, points[0]), 
        (rh_lines_123, points[1]), 
    ]
    xyz = [(10 * i, 10 * i, 10 * i) for i in range(5)]
    py_line_0 = _pl.PyLine(xyz[0], xyz[1], 'x')
    py_line_1 = _pl.PyLine(xyz[1], xyz[2], 'x')
    py_line_2 = _pl.PyLine(xyz[2], xyz[3], 'x')
    py_line_3 = _pl.PyLine(xyz[3], xyz[4], 'x')
    py_lines_012 = [py_line_0, py_line_1, py_line_2]
    py_lines_123 = [py_line_1, py_line_2, py_line_3]

    expected_lists = [
        py_lines_123, 
        py_lines_012, 
    ]
    n = len(try_names)
    for i in range(n):
        _try_some_new_from_rh_lines_and_ref_point(
            method_name, try_names[i], pairs_in[i], expected_lists[i])
    print_test_done(method_name)

def _try_some_new_from_rh_lines_and_ref_point(
    method_name, try_name, pair_in, expected_value
):
    rh_lines_in, ref_point = pair_in
    repr_str = '_pl.PyLine.%s(rh_lines_in, ref_point)' % method_name
    actual_value = eval(repr_str)
    if not actual_value == expected_value:
        print_test_error_message(
            method_name, try_name, expected_value, actual_value)

def test_new_from_rh_line_and_ref_point():
    method_name = 'new_from_rh_line_and_ref_point'
    try_names = [
        'l12, p0', 
        'l12, p1', 
        'l21, p0', 
        'l21, p1', 
    ]
    p0_xyz = ( 0,  0,  0)
    p1_xyz = (10, 10, 10)
    p2_xyz = (20, 20, 20)
    input_tuples = [
        (p1_xyz, p2_xyz, 'l12', p0_xyz), 
        (p1_xyz, p2_xyz, 'l12', p1_xyz), 
        (p2_xyz, p1_xyz, 'l21', p0_xyz), 
        (p2_xyz, p1_xyz, 'l21', p1_xyz), 
    ]
    expected_tuples = [
        (p1_xyz, p2_xyz, ['l12']), 
        (p0_xyz, p1_xyz, ['l12']), 
        (p1_xyz, p2_xyz, ['l21']), 
        (p0_xyz, p1_xyz, ['l21']), 
    ]
    n = len(try_names)
    for i in range(n):
        _try_new_from_rh_line_and_ref_point(
            method_name, try_names[i], input_tuples[i], expected_tuples[i])
    print_test_done(method_name)

def _try_new_from_rh_line_and_ref_point(
    method_name, try_name, input_tuple, expected_tuple
):
    xyz1, xyz2, label, ref_point_xyz = input_tuple
    rh_line = _add_named_line(xyz1, xyz2, label, ref_point_xyz)
    ref_point = _vu.get_point3d(ref_point_xyz)
    py_line = _pl.PyLine.new_from_rh_line_and_ref_point(rh_line, ref_point)
    actual_values = (py_line.tail, py_line.head, py_line.labels)
    expected_values = expected_tuple
    if not actual_values == expected_values:
        print_test_error_message(
            method_name, try_name, expected_values, actual_values)

def _add_named_line(xyz1, xyz2, label, ref_point_xyz):
    named_line = _rs.AddLine(xyz1, xyz2)
    _rs.ObjectName(named_line, label)
    return named_line

def _make_py_lines_and_names_for_get_agnostic():
    names = [
        'l01', 
        'l02', 
        'l12', 
    ]
    xyz0 = ( 0.0,  0.0,  0.0)
    xyz1 = (10.0, 10.0, 10.0)
    xyz2 = (20.0, 20.0, 20.0)
    py_lines = [
        _pl.PyLine(xyz0, xyz1), 
        _pl.PyLine(xyz0, xyz2), 
        _pl.PyLine(xyz1, xyz2), 
    ]
    return (py_lines, names)

def test_some_new_from_agnostics():
    method_name = 'some_new_from_agnostics'
    try_names = [
        'empty_list', 
        'square', 
        'ells', 
        'square_ells', 
    ]
    ag_empty, ag_square, ag_ells, ag_hash = _tu.make_hash_suite_ags()
    square_ag_lines = ag_square['line segments']
    ells_ag_lines = ag_ells['line segments']
    hash_ag_lines = ag_hash['line segments']
    ag_line_lists = [
        [], 
        square_ag_lines, 
        ells_ag_lines, 
        hash_ag_lines, 
    ]
    coord_specs, xyz_specs = _tu._make_hash_suite_spec_lists()
    [   xyz12, xyz13, 
        xyz21, xyz22, 
        xyz23, xyz24, 
        xyz31, xyz32, 
        xyz33, xyz34, 
        xyz42, xyz43, 
        xyz111, xyz444, 
        line_labels, line_weight, 
    ] = xyz_specs
    square_line_xyz_pairs = [
        (xyz22, xyz23), 
        (xyz22, xyz32), 
        (xyz23, xyz33), 
        (xyz32, xyz33), 
    ]
    square_py_lines = []
    for xyz_pair in square_line_xyz_pairs:
        xyz1, xyz2 = xyz_pair
        pl = _pl.PyLine(xyz1, xyz2, line_labels, line_weight)
        square_py_lines.append(pl)
    ells_line_xyz_pairs = [
        (xyz12, xyz22), 
        (xyz13, xyz23), 
        (xyz21, xyz22), 
        (xyz23, xyz24), 
        (xyz31, xyz32), 
        (xyz32, xyz42), 
        (xyz33, xyz34), 
        (xyz33, xyz43), 
    ]
    ells_py_lines = []
    for xyz_pair in ells_line_xyz_pairs:
        xyz1, xyz2 = xyz_pair
        pl = _pl.PyLine(xyz1, xyz2, line_labels, line_weight)
        ells_py_lines.append(pl)
    hash_line_xyz_pairs = [
        (xyz12, xyz42), 
        (xyz13, xyz43), 
        (xyz21, xyz24), 
        (xyz31, xyz34), 
    ]
    hash_py_lines = []
    for xyz_pair in hash_line_xyz_pairs:
        xyz1, xyz2 = xyz_pair
        pl = _pl.PyLine(xyz1, xyz2, line_labels, line_weight)
        hash_py_lines.append(pl)

    expected_values = [
        [], 
        sorted(square_py_lines), 
        sorted(ells_py_lines), 
        sorted(hash_py_lines), 
    ]
    n = len(try_names)
    for i in range(n):
        _try_some_new_from_agnostics(
            method_name, try_names[i], ag_line_lists[i], expected_values[i])
    print_test_done(method_name)

def _try_some_new_from_agnostics(
    method_name, try_name, ag_lines, expected_value
):
    actual_value = _pl.PyLine.some_new_from_agnostics(ag_lines)
    if not actual_value == expected_value:
        print_test_error_message(
            method_name, try_name, expected_value, actual_value)

def test_new_from_agnostic():
    method_name = 'new_from_agnostic'
    try_names = [
        'ag_01____', 
        'ag_12___2', 
        'ag_23_a_3', 
        'ag_34_ab4', 
        'ag_45_b_5', 
    ]
    xyz000, xyz110, xyz220, xyz330, xyz440, xyz550 = (
        ( 0,  0, 0), 
        (10, 10, 0), 
        (20, 20, 0), 
        (30, 30, 0), 
        (40, 40, 0), 
        (50, 50, 0))
    tuples = [
        (xyz000, xyz110), 
        (xyz110, xyz220, [        ], 0.02), 
        (xyz220, xyz330, ['a'     ], 0.03), 
        (xyz330, xyz440, ['a', 'b'], 0.04), 
        (xyz440, xyz550, ['b'     ], 0.05), 
    ]
    ag_lines = []
    for tup in tuples:
        xyz1 = tup[0]
        xyz2 = tup[1]
        n = len(tup)
        if n == 2:
            ag_line = _a.Agnostic.new_ag_line(xyz1, xyz2)
        elif n == 3:
            ag_line = _a.Agnostic.new_ag_line(xyz1, xyz2, tup[2])
        elif n == 4:
            ag_line = _a.Agnostic.new_ag_line(xyz1, xyz2, tup[2], tup[3])
        else:
            print('tuple too long!')
        ag_lines.append(ag_line)
    expected_values = [
        _pl.PyLine(xyz000, xyz110), 
        _pl.PyLine(xyz110, xyz220, [        ], 0.02), 
        _pl.PyLine(xyz220, xyz330, ['a'     ], 0.03), 
        _pl.PyLine(xyz330, xyz440, ['a', 'b'], 0.04), 
        _pl.PyLine(xyz440, xyz550, ['b'     ], 0.05), 
    ]
    n = len(try_names)
    for i in range(n):
        _try_new_from_agnostic(
            method_name, try_names[i], ag_lines[i], expected_values[i])
    print_test_done(method_name)

def _try_new_from_agnostic(
    method_name, try_name, ag_line, expected_value
):
    actual_value = _pl.PyLine.new_from_agnostic(ag_line)
    if not actual_value == expected_value:
        print_test_error_message(
            method_name, try_name, expected_value, actual_value)

def test_draw():
    method_name = 'draw'
    _vm.ViewMain.clear_all()
    _l.Layer.new('layer_0')
    _l.Layer.new('layer_1')
    _l.Layer.new('layer_2')
    try_names = [
        '000_', 
        '111a', 
        '222bc', 
    ]
    p000 = ( 0,  0, 0)
    p110 = (10, 10, 0)
    p110 = (10, 10, 0)
    pl_at_000 = _pl.PyLine(p000, p110, [])
    pl_at_100 = _pl.PyLine(p000, p110, 'a')
    pl_at_200 = _pl.PyLine(p000, p110, ['b', 'c'])
    input_tuples = [
        (pl_at_000, ( 0, 0, 0), 'layer_0'), 
        (pl_at_100, (10, 0, 0), 'layer_1'), 
        (pl_at_200, (20, 0, 0), 'layer_2'), 
    ]
    expected_tuples = [
        (True, ''), 
        (True, 'a'), 
        (True, 'b#c'), 
    ]
    n = len(try_names)
    for i in range(n):
        _try_draw(
            method_name, try_names[i], input_tuples[i], expected_tuples[i])
    print_test_done(method_name)

def _try_draw(method_name, try_name, input_tuple, expected_tuple):
    py_line, ref_point, layer_name = input_tuple
    line = py_line.draw(ref_point, layer_name)
    is_line = _rs.IsLine(line)
    actual_tuple = (is_line, py_line.labels_str)
    if not actual_tuple == expected_tuple:
        print_test_error_message(
            method_name, try_name, expected_tuple, actual_tuple)

def test___eq__():
    method_name = '__eq__'
    ref_line, ref_line_name, test_lines, test_line_names = (
        _make_lines_and_names())
    expected_values = [
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, True , False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
    ]
    n = len(test_lines)
    for i in range(n):
        try_name = '%s == %s' % (ref_line_name, test_line_names[i])
        test_line = test_lines[i]
        expected_value = expected_values[i]
        _try___eq__(
            method_name, try_name, ref_line, test_line, expected_value)
    print_test_done(method_name)

def _try___eq__(method_name, try_name, ref_line, test_line, expected_value):
    actual_value = (ref_line == test_line)
    if not actual_value == expected_value:
        print_test_error_message(
            method_name, try_name, expected_value, actual_value)

def test___ge__():
    method_name = '__ge__'
    ref_line, ref_line_name, test_lines, test_line_names = (
        _make_lines_and_names())
    expected_values = [
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
    ]
    n = len(test_lines)
    for i in range(n):
        try_name = '%s >= %s' % (ref_line_name, test_line_names[i])
        test_line = test_lines[i]
        expected_value = expected_values[i]
        _try___ge__(
            method_name, try_name, ref_line, test_line, expected_value)
    print_test_done(method_name)

def _try___ge__(method_name, try_name, ref_line, test_line, expected_value):
    actual_value = (ref_line >= test_line)
    if not actual_value == expected_value:
        print_test_error_message(
            method_name, try_name, expected_value, actual_value)

def test___gt__():
    method_name = '__gt__'
    ref_line, ref_line_name, test_lines, test_line_names = (
        _make_lines_and_names())
    expected_values = [
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
    ]
    n = len(test_lines)
    for i in range(n):
        try_name = '%s > %s' % (ref_line_name, test_line_names[i])
        test_line = test_lines[i]
        expected_value = expected_values[i]
        _try___gt__(
            method_name, try_name, ref_line, test_line, expected_value)
    print_test_done(method_name)

def _try___gt__(method_name, try_name, ref_line, test_line, expected_value):
    actual_value = (ref_line > test_line)
    if not actual_value == expected_value:
        print_test_error_message(
            method_name, try_name, expected_value, actual_value)

def test___le__():
    method_name = '__le__'
    ref_line, ref_line_name, test_lines, test_line_names = (
        _make_lines_and_names())
    expected_values = [
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
    ]
    n = len(test_lines)
    for i in range(n):
        try_name = '%s <= %s' % (ref_line_name, test_line_names[i])
        test_line = test_lines[i]
        expected_value = expected_values[i]
        _try___le__(
            method_name, try_name, ref_line, test_line, expected_value)
    print_test_done(method_name)

def _try___le__(method_name, try_name, ref_line, test_line, expected_value):
    actual_value = (ref_line <= test_line)
    if not actual_value == expected_value:
        print_test_error_message(
            method_name, try_name, expected_value, actual_value)

def test___lt__():
    method_name = '__lt__'
    ref_line, ref_line_name, test_lines, test_line_names = (
        _make_lines_and_names())
    expected_values = [
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, False, False, False, False, 
        False, False, False, False, False, True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
    ]
    n = len(test_lines)
    for i in range(n):
        try_name = '%s < %s' % (ref_line_name, test_line_names[i])
        test_line = test_lines[i]
        expected_value = expected_values[i]
        _try___lt__(
            method_name, try_name, ref_line, test_line, expected_value)
    print_test_done(method_name)

def _try___lt__(method_name, try_name, ref_line, test_line, expected_value):
    actual_value = (ref_line < test_line)
    if not actual_value == expected_value:
        print_test_error_message(
            method_name, try_name, expected_value, actual_value)

def test___ne__():
    method_name = '__ne__'
    ref_line, ref_line_name, test_lines, test_line_names = (
        _make_lines_and_names())
    expected_values = [
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , False, True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
        True , True , True , True , True , True , True , True , True , 
    ]
    n = len(test_lines)
    for i in range(n):
        try_name = '%s != %s' % (ref_line_name, test_line_names[i])
        test_line = test_lines[i]
        expected_value = expected_values[i]
        _try___ne__(
            method_name, try_name, ref_line, test_line, expected_value)
    print_test_done(method_name)

def _try___ne__(method_name, try_name, ref_line, test_line, expected_value):
    actual_value = (ref_line != test_line)
    if not actual_value == expected_value:
        print_test_error_message(
            method_name, try_name, expected_value, actual_value)

def _make_lines_and_names():
    c = math.cos(TAU / 12)
    s = math.sin(TAU /  6)
    # print('c < s: %s' % c < s)      # False
    # print('c == s: %s' % c == s)    # False
    # print('c > s: %s' % c > s)      # True
    xyz0c = (0.0, 0.0, c)
    xyz1c = (1.1, 1.1, c)
    xyz2c = (2.2, 2.2, c)
    xyz3c = (3.3, 3.3, c)
    xyz4c = (4.4, 4.4, c)
    xyz5c = (5.5, 5.5, c)
    xyz6c = (6.6, 6.6, c)
    xyz7c = (7.7, 7.7, c)
    xyz5s = (5.5, 5.5, s)
    xyz_pairs = [
        (xyz0c, xyz1c), (xyz0c, xyz2c), (xyz0c, xyz4c), 
        (xyz0c, xyz5c), (xyz0c, xyz7c), 
        (xyz2c, xyz4c), (xyz2c, xyz5c), (xyz2c, xyz7c), 
        (xyz3c, xyz4c), (xyz3c, xyz5c), (xyz3c, xyz7c), 
        (xyz5c, xyz7c), 
        (xyz6c, xyz7c), 
    ]
    labels = ['', 'a', 'b']
    weights = [0.01, 0.05, 0.09]
    geometry_names = [
        'c0______', 'c01_____', 'c0123___', 'c01234__', 'c0123456', 
        'c__23___', 'c__234__', 'c__23456', 
        'c___3___', 'c___34__', 'c___3456', 
        'c_____56', 
        'c______6', 
    ]
    label_names = ['_', 'a', 'b']
    weight_names = ['1', '5', '9']
    ref_line = _pl.PyLine(xyz2c, xyz5s, labels[1], weights[1])
    ref_line_name = 's__234__%s%s' % (label_names[1], weight_names[1])
    test_lines = []
    test_line_names = []
    n_xyz_pairs = len(xyz_pairs)
    n_labels = len(labels)
    n_weights = len(weights)
    for i in range(n_xyz_pairs):
        for j in range(n_labels):
            for k in range(n_weights):
                xyz1, xyz2 = xyz_pairs[i]
                label = labels[j]
                weight = weights[k]
                test_line = _pl.PyLine(xyz1, xyz2, label, weight)
                test_lines.append(test_line)
                geometry_name = geometry_names[i]
                label_name = label_names[j]
                weight_name = weight_names[k]
                test_line_name = '%s%s%s' % (
                    geometry_name, label_name, weight_name)
                test_line_names.append(test_line_name)
    return (ref_line, ref_line_name, test_lines, test_line_names)

def test___str__():
    method_name = '__str__'
    try_names = [
        'no_label', 
        'single_label', 
        'double_label', 
        'unsorted_labels', 
    ]
    xyz1 = (1.1, 1.1, 1.1)
    xyz2 = (2.2, 2.2, 2.2)
    py_lines = [
        _pl.PyLine(xyz1, xyz2), 
        _pl.PyLine(xyz1, xyz2, 'a'), 
        _pl.PyLine(xyz1, xyz2, ['a', 'a']), 
        _pl.PyLine(xyz1, xyz2, ['b', 'a'], 0.1), 
    ]
    expected_values = [
        "((1.1, 1.1, 1.1), (2.2, 2.2, 2.2), [], 1.0)", 
        "((1.1, 1.1, 1.1), (2.2, 2.2, 2.2), ['a'], 1.0)", 
        "((1.1, 1.1, 1.1), (2.2, 2.2, 2.2), ['a'], 1.0)", 
        "((1.1, 1.1, 1.1), (2.2, 2.2, 2.2), ['a', 'b'], 0.1)", 
    ]
    n = len(try_names)
    for i in range(n):
        _try___str__(
            method_name, try_names[i], py_lines[i], expected_values[i])
    print_test_done(method_name)

def _try___str__(method_name, try_name, py_line, expected_value):
    actual_value = str(py_line)
    if not actual_value == expected_value:
        print_test_error_message(
            method_name, try_name, expected_value, actual_value)

def test___repr__():
    method_name = '__repr__'
    xyz1 = (1.1, 1.1, 1.1)
    xyz2 = (2.2, 2.2, 2.2)
    py_lines = [
        _pl.PyLine(xyz1, xyz2), 
        _pl.PyLine(xyz1, xyz2, []), 
        _pl.PyLine(xyz1, xyz2, 'a'), 
        _pl.PyLine(xyz1, xyz2, ['a']), 
        _pl.PyLine(xyz1, xyz2, ['a', 'b']), 
        _pl.PyLine(xyz1, xyz2, ['a', 'b'], 0.1), 
    ]
    n = len(py_lines)
    for i in range(n):
        py_line = py_lines[i]
        try_name = str(py_line)
        _try___repr__(method_name, try_name, py_line, py_line)
    print_test_done(method_name)

def _try___repr__(method_name, try_name, py_line, expected_value):
    actual_value = eval(repr(py_line))
    if not actual_value == expected_value:
        print_test_error_message(
            method_name, try_name, expected_value, actual_value)

def test_make_lines_and_names():
    ref_line, ref_line_name, lines, line_names = _make_lines_and_names()
    print('line_names: %s' % line_names)
    """
    line_names: [
        'c0_______1', '_5', '_9', 'a1', 'a5', 'a9', 'b1', 'b5', 'b9', 
        'c01______1', '_5', '_9', 'a1', 'a5', 'a9', 'b1', 'b5', 'b9', 
        'c0123____1', '_5', '_9', 'a1', 'a5', 'a9', 'b1', 'b5', 'b9', 
        'c01234___1', '_5', '_9', 'a1', 'a5', 'a9', 'b1', 'b5', 'b9', 
        'c0123456_1', '_5', '_9', 'a1', 'a5', 'a9', 'b1', 'b5', 'b9', 
        'c__23____1', '_5', '_9', 'a1', 'a5', 'a9', 'b1', 'b5', 'b9', 
        'c__234___1', '_5', '_9', 'a1', 'a5', 'a9', 'b1', 'b5', 'b9', 
        'c__23456_1', '_5', '_9', 'a1', 'a5', 'a9', 'b1', 'b5', 'b9', 
        'c___3____1', '_5', '_9', 'a1', 'a5', 'a9', 'b1', 'b5', 'b9', 
        'c___34___1', '_5', '_9', 'a1', 'a5', 'a9', 'b1', 'b5', 'b9', 
        'c___3456_1', '_5', '_9', 'a1', 'a5', 'a9', 'b1', 'b5', 'b9', 
        'c_____56_1', '_5', '_9', 'a1', 'a5', 'a9', 'b1', 'b5', 'b9', 
        'c______6_1', '_5', '_9', 'a1', 'a5', 'a9', 'b1', 'b5', 'b9', 
    ]
    """

test___init__()
test_some_new_from_rh_lines_and_ref_point()
test_new_from_rh_line_and_ref_point()
test_some_new_from_agnostics()
test_new_from_agnostic()
test_draw()
test___eq__()
test___ge__()
test___gt__()
test___le__()
test___lt__()
test___ne__()
test___str__()
test___repr__()

# test_make_lines_and_names()

 



