from view import agnostic as                    _a
from controller import controller_main as       _cm
from view import layer as                       _l
from view import py_form as                     _pf
from view import py_line as                     _pl
from view import py_point as                    _pp
from view import py_rule as                     _pr
from view import settings as                    _s
import sortalgi as                              _sgi

def print_test_error_message(
    method_name, try_name, expected_value, actual_value
):
    message = "%s: %s:\n    expected '%s'; got '%s'" % (
        method_name, try_name, expected_value, actual_value)
    print(message)

def print_test_done(method_name):
    string = "Done: test_%s" % method_name
    print(string)

def draw_hash_suite_forms():
    py_forms = make_hash_suite_py_forms()
    n = len(py_forms)
    for i in range(n):
        py_form = py_forms[i]
        dx = horizontal_spacing = 150
        dy = vertical_spacing = 150
        # draw_point = (dx * i, -dy, 0)
        layer_name = 'new_shape_%i' % i
        _l.Layer.new(layer_name)
        py_form.draw(layer_name)

def make_hash_suite_py_rules():
    pf_empty, pf_square, pf_ells, pf_hash = py_forms = (
        make_hash_suite_py_forms())
    n = len(py_forms)
    for i in range(1, 4):
        for j in range(4):
            py_rule = _pr.PyRule(py_left, py_right, name)
    py_rules = []
    return py_rules

def make_hash_suite_py_forms():
    hash_point_specs, square_line_specs, ells_line_specs, hash_line_specs = (
        make_hash_suite_specs())
    hash_py_points = [
        _pp.PyPoint(sp[0], sp[1], sp[2], sp[3]) for sp in hash_point_specs]
    square_py_lines = [
        _pl.PyLine(sp[0], sp[1], sp[2], sp[3]) for sp in square_line_specs]
    ells_py_lines = [
        _pl.PyLine(sp[0], sp[1], sp[2], sp[3]) for sp in ells_line_specs]
    hash_py_lines = [
        _pl.PyLine(sp[0], sp[1], sp[2], sp[3]) for sp in hash_line_specs]
    py_empty = _pf.PyForm()
    py_square = _pf.PyForm([], square_py_lines)
    py_ells = _pf.PyForm(hash_py_points, ells_py_lines)
    py_hash = _pf.PyForm(hash_py_points, hash_py_lines)
    return (py_empty, py_square, py_ells, py_hash)

def make_hash_suite_specs():
    coord_specs, xyz_specs = _make_hash_suite_spec_lists()
    x1, y1, z1, x2, y2, z2, x3, y3, z3, x4, y4, z4, point_label = coord_specs
    (   xy12, xy13, xy21, xy22, 
        xy23, xy24, xy31, xy32, 
        xy33, xy34, xy42, xy43, 
        xyz111, xyz444, 
        line_labels, line_weight, 
    ) = xyz_specs
    hash_point_specs = [
        (x1, y2, 0, point_label), 
        (x1, y3, 0, point_label), 
        (x2, y1, 0, point_label), 
        (x2, y4, 0, point_label), 
        (x3, y1, 0, point_label), 
        (x3, y4, 0, point_label), 
        (x4, y2, 0, point_label), 
        (x4, y3, 0, point_label), 
    ]
    square_line_specs = [
        (xy22, xy23, line_labels, line_weight), 
        (xy22, xy32, line_labels, line_weight), 
        (xy23, xy33, line_labels, line_weight), 
        (xy32, xy33, line_labels, line_weight), 
    ]
    ell_line_specs = [
        (xy12, xy22, line_labels, line_weight), 
        (xy13, xy23, line_labels, line_weight), 
        (xy21, xy22, line_labels, line_weight), 
        (xy23, xy24, line_labels, line_weight), 
        (xy31, xy32, line_labels, line_weight), 
        (xy32, xy42, line_labels, line_weight), 
        (xy33, xy34, line_labels, line_weight), 
        (xy33, xy43, line_labels, line_weight), 
    ]
    hash_line_specs = [
        (xy12, xy42, line_labels, line_weight), 
        (xy13, xy43, line_labels, line_weight), 
        (xy21, xy24, line_labels, line_weight), 
        (xy31, xy34, line_labels, line_weight), 
    ]
    return (
        hash_point_specs, square_line_specs, ell_line_specs, hash_line_specs)

def make_hash_suite_ag_elements():
    coord_specs, xyz_specs = _make_hash_suite_spec_lists()
    x1, y1, z1, x2, y2, z2, x3, y3, z3, x4, y4, z4, point_label = coord_specs
    (   xy12, xy13, xy21, xy22, 
        xy23, xy24, xy31, xy32, 
        xy33, xy34, xy42, xy43, 
        xyz111, xyz444, 
        line_labels, line_weight, 
    ) = xyz_specs
    point_attrib_dict = {'labels': [point_label]}
    line_attrib_dict = {
        'labels': [], 
        'weight': 1.0, 
    }
    hash_ag_points = [
        (xy12, point_attrib_dict), 
        (xy13, point_attrib_dict), 
        (xy21, point_attrib_dict), 
        (xy24, point_attrib_dict), 
        (xy31, point_attrib_dict), 
        (xy34, point_attrib_dict), 
        (xy42, point_attrib_dict), 
        (xy43, point_attrib_dict), 
    ]
    square_ag_lines = [
        ((xy22, xy23), line_attrib_dict), 
        ((xy22, xy32), line_attrib_dict), 
        ((xy23, xy33), line_attrib_dict), 
        ((xy32, xy33), line_attrib_dict), 
    ]
    ell_ag_lines = [
        ((xy12, xy22), line_attrib_dict), 
        ((xy13, xy23), line_attrib_dict), 
        ((xy21, xy22), line_attrib_dict), 
        ((xy23, xy24), line_attrib_dict), 
        ((xy31, xy32), line_attrib_dict), 
        ((xy32, xy42), line_attrib_dict), 
        ((xy33, xy34), line_attrib_dict), 
        ((xy33, xy43), line_attrib_dict), 
    ]
    hash_ag_lines = [
        ((xy12, xy42), line_attrib_dict), 
        ((xy13, xy43), line_attrib_dict), 
        ((xy21, xy24), line_attrib_dict), 
        ((xy31, xy34), line_attrib_dict), 
    ]
    return (hash_ag_points, square_ag_lines, ell_ag_lines, hash_ag_lines)

def make_hash_suite_dict():
    coord_specs, xy_specs = _make_hash_suite_spec_lists()
    (   x1, y1, z1, x2, y2, z2, 
        x3, y3, z4, x4, y4, z4, 
        point_label, 
    ) = coord_specs
    (   xy12, xy13, xy21, xy22, 
        xy23, xy24, xy31, xy32, 
        xy33, xy34, xy42, xy43, 
        xyz111, xyz444, 
        line_labels, line_weight, 
    ) = xy_specs
    lw = line_weight

    point_specs = [
        (x1, y2, 0, 'a'), 
        (x1, y3, 0, 'a'), 
        (x2, y1, 0, 'a'), 
        (x2, y4, 0, 'a'), 
        (x3, y1, 0, 'a'), 
        (x3, y4, 0, 'a'), 
        (x4, y2, 0, 'a'), 
        (x4, y3, 0, 'a'), 
    ]
    (   ap_12, ap_13, ap_21, ap_24, ap_31, ap_34, ap_42, ap_43, 
    ) = _a.Agnostic.new_ag_points(point_specs)
    line_specs = [
        (xy12, xy22, [], lw), (xy12, xy42, [], lw), (xy12, xy43, [], lw), 
        (xy13, xy23, [], lw), (xy13, xy33, [], lw), (xy13, xy43, [], lw), 
        (xy21, xy22, [], lw), (xy21, xy23, [], lw), (xy21, xy24, [], lw), 
        (xy22, xy23, [], lw), (xy22, xy24, [], lw), 
        (xy22, xy32, [], lw), (xy22, xy42, [], lw), 
        (xy23, xy24, [], lw), (xy23, xy33, [], lw), (xy23, xy43, [], lw), 
        (xy31, xy32, [], lw), (xy31, xy33, [], lw), (xy31, xy34, [], lw), 
        (xy32, xy33, [], lw), (xy32, xy34, [], lw), (xy32, xy42, [], lw), 
        (xy33, xy34, [], lw), (xy33, xy43, [], lw), 
        (xyz111, xyz444, [], lw), 
    ]
    (   al_12_22, al_12_42, al_12_43, 
        al_13_23, al_13_33, al_13_43, 
        al_21_22, al_21_23, al_21_24, 
        al_22_23, al_22_24, 
        al_22_32, al_22_42, 
        al_23_24, al_23_33, al_23_43, 
        al_31_32, al_31_33, al_31_34, 
        al_32_33, al_32_34, al_32_42, 
        al_33_34, al_33_43, 
        al_111_444, 
    ) = _a.Agnostic.new_ag_lines(line_specs)
    ag_empty = {}
    ag_point = {
        'points': [
            ap_12], 
        'line segments': [], }
    ag_points = {
        'points': [
            ap_12, ap_13, 
            ap_21, ap_24, 
            ap_31, ap_34, 
            ap_42, ap_43, ], 
        'line segments': [], }
    ag_square = {
        'points': [], 
        'line segments': [
            al_22_23, 
            al_22_32, 
            al_23_33, 
            al_32_33, ], }
    ag_ells = {
        'points': [
            ap_12, ap_13, 
            ap_21, ap_24, 
            ap_31, ap_34, 
            ap_42, ap_43, ], 
        'line segments': [
            al_12_22, 
            al_13_23, 
            al_21_22, 
            al_23_24, 
            al_31_32, 
            al_32_42, 
            al_33_34, 
            al_33_43, ], }
    ag_L11 = {
        'points': [
            ap_12, ap_21, ], 
        'line segments': [
            al_12_22, al_21_22, ], }
    ag_L12 = {
        'points': [
            ap_13, ap_24, ], 
        'line segments': [
            al_13_23, 
            al_23_24, ], }
    ag_L21 = {
        'points': [
            ap_31, ap_42, ], 
        'line segments': [
            al_31_32, al_32_42, ], }
    ag_L22 = {
        'points': [
            ap_34, ap_43, ], 
        'line segments': [
            al_33_34, al_33_43, ], }
    ag_L11L12L21 = {
        'points': [
            ap_12, ap_13, 
            ap_21, ap_24, 
            ap_31, 
            ap_42, 
        ], 
        'line segments': [
            al_12_22, 
            al_13_23, 
            al_21_22, 
            al_23_24, 
            al_31_32, 
            al_32_42, 
            # al_33_34, 
            # al_33_43, 
        ], }
    ag_hash = {
        'points': [
            ap_12, ap_13, 
            ap_21, ap_24, 
            ap_31, ap_34, 
            ap_42, ap_43, ], 
        'line segments': [
            al_12_42, 
            al_13_43, 
            al_21_24, 
            al_31_34, ], }
    ag_hash_minus_L11 = {
        'points': [
            ap_13, ap_24, ap_31, ap_34, ap_42, ap_43, ], 
        'line segments': [
            al_13_43, al_22_24, al_22_42, al_31_34, ], } #
    ag_hash_minus_L12 = {
        'points': [
            ap_12, ap_21, ap_31, ap_34, ap_42, ap_43, ], 
        'line segments': [
            al_12_42, al_21_23, al_23_43, al_31_34, ], } #
    ag_hash_minus_L21 = {
        'points': [
            ap_12, ap_13, ap_21, ap_24, ap_34, ap_43, ], 
        'line segments': [
            al_12_43, al_13_43, al_21_24, al_32_34, ], }
    ag_hash_minus_L22 = {
        'points': [
            ap_12, ap_13, ap_21, ap_24, ap_31, ap_42, ], 
        'line segments': [
            al_12_42, al_13_33, al_21_24, al_31_33, ], }
    ag_xyz_line = {
        'points': [], 
        'line segments': [
            al_111_444, ], }
    pf_empty = _pf.PyForm.new_from_agnostic(ag_empty)
    pf_point = _pf.PyForm.new_from_agnostic(ag_point)
    pf_points = _pf.PyForm.new_from_agnostic(ag_points)
    pf_square = _pf.PyForm.new_from_agnostic(ag_square)
    pf_L11 = _pf.PyForm.new_from_agnostic(ag_L11)
    pf_L12 = _pf.PyForm.new_from_agnostic(ag_L12)
    pf_L21 = _pf.PyForm.new_from_agnostic(ag_L21)
    pf_L22 = _pf.PyForm.new_from_agnostic(ag_L22)
    pf_L11L12L21 = _pf.PyForm.new_from_agnostic(ag_L11L12L21)
    pf_ells = _pf.PyForm.new_from_agnostic(ag_ells)
    pf_hash = _pf.PyForm.new_from_agnostic(ag_hash)
    pf_hash_minus_L11 = _pf.PyForm.new_from_agnostic(ag_hash_minus_L11)
    pf_hash_minus_L12 = _pf.PyForm.new_from_agnostic(ag_hash_minus_L12)
    pf_hash_minus_L21 = _pf.PyForm.new_from_agnostic(ag_hash_minus_L21)
    pf_hash_minus_L22 = _pf.PyForm.new_from_agnostic(ag_hash_minus_L22)
    pf_xyz_line = _pf.PyForm.new_from_agnostic(ag_xyz_line)
    pr_point_to_empty = _pr.PyRule(pf_point, pf_empty) 
    pr_points_to_empty = _pr.PyRule(pf_points, pf_empty) 
    pr_points_to_points = _pr.PyRule(pf_points, pf_points) 
    pr_points_to_square = _pr.PyRule(pf_points, pf_square) 
    pr_points_to_ells = _pr.PyRule(pf_points, pf_ells) 
    pr_points_to_hash = _pr.PyRule(pf_points, pf_hash) 
    pr_square_to_empty = _pr.PyRule(pf_square, pf_empty)
    pr_square_to_points = _pr.PyRule(pf_square, pf_points)
    pr_square_to_square = _pr.PyRule(pf_square, pf_square)
    pr_square_to_ells = _pr.PyRule(pf_square, pf_ells)
    pr_square_to_hash = _pr.PyRule(pf_square, pf_hash)
    pr_L11_to_empty = _pr.PyRule(pf_L11, pf_empty)
    pr_L12_to_empty = _pr.PyRule(pf_L12, pf_empty)
    pr_L21_to_empty = _pr.PyRule(pf_L21, pf_empty)
    pr_L22_to_empty = _pr.PyRule(pf_L22, pf_empty)
    pr_L11L12L21_to_empty = _pr.PyRule(pf_L11L12L21, pf_empty)
    pr_ells_to_empty = _pr.PyRule(pf_ells, pf_empty)
    pr_ells_to_points = _pr.PyRule(pf_ells, pf_points)
    pr_ells_to_square = _pr.PyRule(pf_ells, pf_square)
    pr_ells_to_ells = _pr.PyRule(pf_ells, pf_ells)
    pr_ells_to_hash = _pr.PyRule(pf_ells, pf_hash)
    pr_hash_to_empty = _pr.PyRule(pf_hash, pf_empty)
    pr_hash_to_points = _pr.PyRule(pf_hash, pf_points)
    pr_hash_to_square = _pr.PyRule(pf_hash, pf_square)
    pr_hash_to_ells = _pr.PyRule(pf_hash, pf_ells)
    pr_hash_to_hash = _pr.PyRule(pf_hash, pf_hash)
    hash_suite_dict = {
        'ag_empty': ag_empty, 
        'ag_points': ag_points, 
        'ag_square': ag_square, 
        'ag_L11': ag_L11, 
        'ag_L12': ag_L12, 
        'ag_L21': ag_L21, 
        'ag_L22': ag_L22, 
        'ag_L11L12L21': ag_L11L12L21, 
        'ag_ells': ag_ells, 
        'ag_hash': ag_hash, 
        'pf_empty': pf_empty, 
        'pf_point': pf_point, 
        'pf_points': pf_points, 
        'pf_square': pf_square, 
        'pf_L11': pf_L11, 
        'pf_L12': pf_L12, 
        'pf_L21': pf_L21, 
        'pf_L22': pf_L22, 
        'pf_ells': pf_ells, 
        'pf_hash': pf_hash, 
        'pf_hash_minus_L11': pf_hash_minus_L11, 
        'pf_hash_minus_L12': pf_hash_minus_L12, 
        'pf_hash_minus_L21': pf_hash_minus_L21, 
        'pf_hash_minus_L22': pf_hash_minus_L22, 
        'pf_xyz_line': pf_xyz_line, 
        'pr_point_to_empty': pr_point_to_empty, 
        'pr_points_to_empty': pr_points_to_empty, 
        'pr_points_to_points': pr_points_to_points, 
        'pr_points_to_square': pr_points_to_square, 
        'pr_points_to_ells': pr_points_to_ells, 
        'pr_points_to_hash': pr_points_to_hash, 
        'pr_square_to_empty': pr_square_to_empty, 
        'pr_square_to_points': pr_square_to_points, 
        'pr_square_to_square': pr_square_to_square, 
        'pr_square_to_ells': pr_square_to_ells, 
        'pr_square_to_hash': pr_square_to_hash, 
        'pr_L22_to_empty': pr_L22_to_empty, 
        'pr_L11L12L21_to_empty': pr_L11L12L21_to_empty, 
        'pr_ells_to_empty': pr_ells_to_empty, 
        'pr_ells_to_points': pr_ells_to_points, 
        'pr_ells_to_square': pr_ells_to_square, 
        'pr_ells_to_ells': pr_ells_to_ells, 
        'pr_ells_to_hash': pr_ells_to_hash, 
        'pr_hash_to_empty': pr_hash_to_empty, 
        'pr_hash_to_points': pr_hash_to_points, 
        'pr_hash_to_square': pr_hash_to_square, 
        'pr_hash_to_ells': pr_hash_to_ells, 
        'pr_hash_to_hash': pr_hash_to_hash, 
    }
    # print('ag_xyz_line: %s' % str(ag_xyz_line))
    # print('pf_xyz_line: %s' % str(pf_xyz_line))
    return hash_suite_dict

def make_hash_suite_ags():
    coord_specs, xyz_specs = _make_hash_suite_spec_lists()
    x1, y1, z1, x2, y2, z2, x3, y3, z3, x4, y4, z4, point_label = coord_specs
    point_attrib_dict = {'labels': [point_label]}
    (   xy12, xy13, xy21, xy22, 
        xy23, xy24, xy31, xy32, 
        xy33, xy34, xy42, xy43, 
        xyz111, xyz444, 
        line_labels, line_weight, 
    ) = xyz_specs
    line_attrib_dict = {
        'labels': line_labels, 
        'weight': line_weight, 
    }
    ag_empty = {}
    ag_square = {
        'points': [], 
        'line segments': [
            ((xy22, xy23), line_attrib_dict), 
            ((xy22, xy32), line_attrib_dict), 
            ((xy23, xy33), line_attrib_dict), 
            ((xy32, xy33), line_attrib_dict), 
        ], 
    }
    ag_ells = {
        'points': [
            ((x1, y2, 0), point_attrib_dict), 
            ((x1, y3, 0), point_attrib_dict), 
            ((x2, y1, 0), point_attrib_dict), 
            ((x2, y4, 0), point_attrib_dict), 
            ((x3, y1, 0), point_attrib_dict), 
            ((x3, y4, 0), point_attrib_dict), 
            ((x4, y2, 0), point_attrib_dict), 
            ((x4, y3, 0), point_attrib_dict), 
        ], 
        'line segments': [
            ((xy12, xy22), line_attrib_dict), 
            ((xy13, xy23), line_attrib_dict), 
            ((xy21, xy22), line_attrib_dict), 
            ((xy23, xy24), line_attrib_dict), 
            ((xy31, xy32), line_attrib_dict), 
            ((xy32, xy42), line_attrib_dict), 
            ((xy33, xy34), line_attrib_dict), 
            ((xy33, xy43), line_attrib_dict), 
        ], 
    }
    ag_hash = {
        'points': [
            ((x1, y2, 0), point_attrib_dict), 
            ((x1, y3, 0), point_attrib_dict), 
            ((x2, y1, 0), point_attrib_dict), 
            ((x2, y4, 0), point_attrib_dict), 
            ((x3, y1, 0), point_attrib_dict), 
            ((x3, y4, 0), point_attrib_dict), 
            ((x4, y2, 0), point_attrib_dict), 
            ((x4, y3, 0), point_attrib_dict), 
        ], 
        'line segments': [
            ((xy12, xy42), line_attrib_dict), 
            ((xy13, xy43), line_attrib_dict), 
            ((xy21, xy24), line_attrib_dict), 
            ((xy31, xy34), line_attrib_dict), 
        ], 
    }
    return (ag_empty, ag_square, ag_ells, ag_hash)

def _make_hash_suite_spec_lists():
    x1 = y1 = z1 = 150 # =   0
    x2 = y2 = z2 = 170 # =  20
    x3 = y3 = z3 = 230 # =  80
    x4 = y4 = z4 = 250 # = 100
    point_label = 'a'
    xy12 = (x1, y2, 0)
    xy13 = (x1, y3, 0)
    xy21 = (x2, y1, 0)
    xy22 = (x2, y2, 0)
    xy23 = (x2, y3, 0)
    xy24 = (x2, y4, 0)
    xy31 = (x3, y1, 0)
    xy32 = (x3, y2, 0)
    xy33 = (x3, y3, 0)
    xy34 = (x3, y4, 0)
    xy42 = (x4, y2, 0)
    xy43 = (x4, y3, 0)
    xyz111 = (x1, y1, z1)
    xyz444 = (x4, y4, z4)
    line_labels = []
    line_weight = _s.Settings.default_line_weight
    coord_specs = [
        x1, y1, z1, 
        x2, y2, z2, 
        x3, y3, z3, 
        x4, y4, z4, 
        point_label, 
    ]
    xyz_specs = [
        xy12, xy13, 
        xy21, xy22, 
        xy23, xy24, 
        xy31, xy32, 
        xy33, xy34, 
        xy42, xy43, 
        xyz111, xyz444, 
        line_labels, line_weight, 
    ]
    return (coord_specs, xyz_specs)

def make_element_dict():                        ##  2018-05-30 21:09
    w0 = 10
    w1 = 90
    xyz_000 = (w0, w0, w0)
    xyz_001 = (w0, w0, w1)
    xyz_010 = (w0, w1, w0)
    xyz_011 = (w0, w1, w1)
    xyz_100 = (w1, w0, w0)
    xyz_101 = (w1, w0, w1)
    xyz_110 = (w1, w1, w0)
    xyz_111 = (w1, w1, w1)
    pp = _pp.PyPoint(w1, w1, w1, ['a'])
    pl_x = _pl.PyLine(xyz_000, xyz_100)
    pl_y = _pl.PyLine(xyz_000, xyz_010)
    pl_z = _pl.PyLine(xyz_000, xyz_001)
    pl_xy = _pl.PyLine(xyz_000, xyz_110)
    pl_xz = _pl.PyLine(xyz_000, xyz_101)
    pl_yz = _pl.PyLine(xyz_000, xyz_011)
    pl_xyz = _pl.PyLine(xyz_000, xyz_111)
    pf_empty = _pf.PyForm([], [])
    pf_point = _pf.PyForm([pp], [])
    pf_xy = _pf.PyForm([], [pl_xy])
    pf_xz = _pf.PyForm([], [pl_xz])
    pf_yz = _pf.PyForm([], [pl_yz])
    pf_xyz = _pf.PyForm([], [pl_xyz])
    pr_point_empty = _pr.PyRule(pf_point, pf_empty)
    pr_point_point = _pr.PyRule(pf_point, pf_point)
    pr_point_xyz = _pr.PyRule(pf_point, pf_xyz)
    pr_xy_empty = _pr.PyRule(pf_xy, pf_empty)
    pr_xy_point = _pr.PyRule(pf_xy, pf_point)
    pr_xy_xy = _pr.PyRule(pf_xy, pf_xy)
    pr_xz_empty = _pr.PyRule(pf_xz, pf_empty)
    pr_xz_point = _pr.PyRule(pf_xz, pf_point)
    pr_xz_xy = _pr.PyRule(pf_xz, pf_xy)
    pr_xz_xz = _pr.PyRule(pf_xz, pf_xz)
    pr_yz_empty = _pr.PyRule(pf_yz, pf_empty)
    pr_yz_point = _pr.PyRule(pf_yz, pf_point)
    pr_yz_xy = _pr.PyRule(pf_yz, pf_xy)
    pr_yz_xz = _pr.PyRule(pf_yz, pf_xz)
    pr_yz_yz = _pr.PyRule(pf_yz, pf_yz)
    pr_xyz_empty = _pr.PyRule(pf_xyz, pf_empty)
    pr_xyz_point = _pr.PyRule(pf_xyz, pf_point)
    pr_xyz_xy = _pr.PyRule(pf_xyz, pf_xy)
    pr_xyz_xz = _pr.PyRule(pf_xyz, pf_xz)
    pr_xyz_yz = _pr.PyRule(pf_xyz, pf_yz)
    pr_xyz_xyz = _pr.PyRule(pf_xyz, pf_xyz)
    element_dict = {
        'w0': w0, 
        'w1': w1, 
        'xyz_000': xyz_000, 
        'xyz_001': xyz_001, 
        'xyz_010': xyz_010, 
        'xyz_011': xyz_011, 
        'xyz_100': xyz_100, 
        'xyz_101': xyz_101, 
        'xyz_110': xyz_110, 
        'xyz_111': xyz_111, 
        'pf_empty': pf_empty, 
        'pf_point': pf_point, 
        'pf_xy': pf_xy, 
        'pf_xz': pf_xz, 
        'pf_yz': pf_yz, 
        'pf_xyz': pf_xyz, 
        'pr_point_empty': pr_point_empty, 
        'pr_point_point': pr_point_point, 
        'pr_point_xyz': pr_point_xyz, 
        'pr_xy_empty': pr_xy_empty, 
        'pr_xy_point': pr_xy_point, 
        'pr_xy_xy': pr_xy_xy, 
        'pr_xz_empty': pr_xz_empty, 
        'pr_xz_point': pr_xz_point, 
        'pr_xz_xy': pr_xz_xy, 
        'pr_xz_xz': pr_xz_xz, 
        'pr_yz_empty': pr_yz_empty, 
        'pr_yz_point': pr_yz_point, 
        'pr_yz_xy': pr_yz_xy, 
        'pr_yz_xz': pr_yz_xz, 
        'pr_yz_yz': pr_yz_yz, 
        'pr_xyz_empty': pr_xyz_empty, 
        'pr_xyz_point': pr_xyz_point, 
        'pr_xyz_xy': pr_xyz_xy, 
        'pr_xyz_xz': pr_xyz_xz, 
        'pr_xyz_yz': pr_xyz_yz, 
        'pr_xyz_xyz': pr_xyz_xyz, 
    }
    return element_dict

def make_modular_py_form(line_shape_name='', point_names=[], label='a'):
    """Receives:
        line_shape_name     str ['', 'empty', 'square', 'hash', 'ells']
        point_names         [point_name]
            point_name      str. A 2-character string of the form ij, where i 
                            and j are the x and y indices of the point 
    Makes a py_form of lines and labeled points on a 7 x 7 grid: 0, 20, 40, 
    70, 100, 120, 140. Lines are at indices 1 and 5. Returns:
        py_form             PyForm
    """
    x = y = [0, 20, 40, 70, 100, 120, 140]
    z = 0
    # weight = _s.Settings.default_line_weight

    def _make_xyzs():
        index_pairs = [   
            (0, 1), (0, 5), (1, 0), (1, 1), (1, 5), (1, 6), 
            (5, 0), (5, 1), (5, 5), (5, 6), (6, 1), (6, 5), ]
        xyzs = []
        for pair in index_pairs:
            i = pair[0]
            j = pair[1]
            xyz = (x[i], y[j], z)
            xyzs.append(xyz)
        return xyzs

    def _make_py_lines():
        [   xyz01, xyz05, xyz10, xyz11, xyz15, xyz16, 
            xyz50, xyz51, xyz55, xyz56, xyz61, xyz65, 
        ] = _make_xyzs()
        xyz_pairs = [
            (xyz01, xyz11), (xyz01, xyz61), (xyz05, xyz15), (xyz05, xyz65), 
            (xyz10, xyz11), (xyz10, xyz16), (xyz11, xyz15), (xyz11, xyz51), 
            (xyz15, xyz16), (xyz15, xyz55), (xyz50, xyz51), (xyz50, xyz56), 
            (xyz51, xyz55), (xyz51, xyz61), (xyz55, xyz56), (xyz55, xyz65), ]
        py_lines = []
        for pair in xyz_pairs:
            py_line = _pl.PyLine(pair[0], pair[1], label)
            py_lines.append(py_line)
        return py_lines
        
    def _make_py_line_lists():
        [   pl_0111, pl_0161, pl_0515, pl_0565, 
            pl_1011, pl_1016, pl_1115, pl_1151, 
            pl_1516, pl_1555, pl_5051, pl_5056, 
            pl_5155, pl_5161, pl_5556, pl_5565, 
        ] = _make_py_lines()

        square_py_lines = [
            pl_1115, pl_1151, pl_1555, pl_5155]
        hash_py_lines = [
            pl_0161, pl_0565, pl_1016, pl_5056]
        ells_py_lines = [
            pl_0111, pl_0515, pl_1011, pl_1516, 
            pl_5051, pl_5556, pl_5161, pl_5565, 
        ]
        py_line_lists = (square_py_lines, hash_py_lines, ells_py_lines)
        return py_line_lists

    good_line_shape_names = ['', 'empty', 'square', 'hash', 'ells']
    try:
        if not (
            type(line_shape_name) == str and
            type(point_names) == list and
            type(label) == str
        ):
            raise TypeError
        if not line_shape_name in good_line_shape_names:
            raise ValueError
    except TypeError:
        type_error_message = "The args must be str, [str], str"
        print(type_error_message)
    except ValueError:
        value_error_message = '%s %s' % (
            "The line shape name must be", 
            "'', 'empty', 'square', 'hash', or 'ells'")
        print(value_error_message)
    else:
        py_points = []
        for name in point_names:
            i = int(name[0])
            j = int(name[1])
            xi = x[i]
            yj = y[j]
            py_point = _pp.PyPoint(xi, yj, z, label)
            py_points.append(py_point)

        square_py_lines, hash_py_lines, ells_py_lines = _make_py_line_lists()
        if line_shape_name == '':
            py_lines = []
        elif line_shape_name == 'empty':
            py_lines = []
        elif line_shape_name == 'square':
            py_lines = square_py_lines
        elif line_shape_name == 'hash':
            py_lines = hash_py_lines
        elif line_shape_name == 'ells':
            py_lines = ells_py_lines
        else:
            message = "Making line shape: shouldn't be here"
            print(message)
        py_form = _pf.PyForm(py_points, py_lines)
        return py_form

def make_x_l_suite_py_forms():
    return []

def make_ag_point(xyz, labels_in=[]):
    """Receives:
        xyz                 (num, num, num)
        labels              str or [str, ...]
    """
    if type(labels_in) == str:
        labels_out = [str]
    else:
        labels_str = ', '.join(labels_in)
        labels_out = [labels_str]
    attrib_dict = {'labels': labels_out}
    ag_point = (xyz, attrib_dict)
    return ag_point

def make_point_line_ags():
    points = [
        ((10, 10, 10), {'labels': ['a']}), 
        ((20, 20, 20), {'labels': ['b']}), 
        ((30, 30, 30), {'labels': ['c']}), 
    ]
    line_segments = [
        ((((10, 10, 10), (20, 20, 20))), {'weight': 0.12}), 
        ((((30, 30, 30), (40, 40, 40))), {'weight': 0.34}), 
        ((((50, 50, 50), (60, 60, 60))), {'weight': 0.56}), 
    ]
    ag___ = {}
    ag__l = {
        'points': [],                           # need this line 
        # 'junk': [],                             # or even this line
        'line segments': line_segments,         # this entry is insufficient
    }
    ag_p_ = {
        'points': points,                       # this line is sufficient
        'line segments': [], 
        # 'junk': [], 
    }
    ag_pl = {
        'points': points, 
        'line segments': line_segments, 
    }
    return (ag___, ag__l, ag_p_, ag_pl)
